minor bug fix
[distro-setup] / btrbk-run
index 31649a495cf7373fe9af900233c4fc0994813596..10bd6382c65df24a4ec1efe35a45270e70ad9005 100644 (file)
--- a/btrbk-run
+++ b/btrbk-run
 
 # todo: if we cancel in the middle of a btrfs send, then run again immediately, the received subvolume doesn't get a Received UUID: field, and we won't mount it. Need to figure out a solution that will fix this.
 
-set -eE -o pipefail
-trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
 
-[[ $EUID == 0 ]] || exec sudo -E "$BASH_SOURCE" "$@"
+[[ $EUID == 0 ]] || exec sudo -E "${BASH_SOURCE[0]}" "$@"
 
+source /usr/local/lib/err
 
 usage() {
   cat <<'EOF'
@@ -43,12 +42,14 @@ rsync-dirs() {
 }
 
 
-m() { if $verbose; then printf "$pre %s\n"  "$*"; fi;  "$@"; }
-die() { printf "$pre %s\n" "$*" >&2;  exit 1; }
+pre="${0##*/}: "
+m() { if $verbose; then printf "$pre%s\n"  "$*"; fi;  "$@"; }
+e() { printf "$pre%s\n"  "$*"; }
+die() { printf "$pre%s\n" "$*" >&2;  exit 1; }
 
 # latest $MAIL_HOST
-if [[ -e /b/bash_unpublished/source-semi-priv ]]; then
-  source /b/bash_unpublished/source-semi-priv
+if [[ -e /b/bash_unpublished/source-state ]]; then
+  source /b/bash_unpublished/source-state
 fi
 
 # note q is owned by root:1000
@@ -74,7 +75,6 @@ if [[ -s $default_args_file ]]; then
   sleep 5
 fi
 
-pre="${0##*/}:"
 cron=false
 orig_args=("$@")
 temp=$(getopt -l cron,pull-reexec,help cl:m:npqs:t:vh "$@") || usage 1
@@ -108,15 +108,24 @@ while true; do
   esac
 done
 
-# usefull commands are resume and archive
+# only tested commands are resume and archive
 cmd_arg=${1:-run}
 
+case $cmd_arg in
+  run|resume|archive) : ;;
+  *) die "untested command arg" ;;
+esac
+
+if (( $# > 1 )); then
+  die: "only 1 nonoption arg is supported"
+fi
+
 if [[ -v targets && $source ]]; then
   die "error: -t and -s are mutually exclusive"
 fi
 
 if $verbose; then
-  printf "$pre options: conf_only=%s\ndry_run=%s\nrate_limit=%s\nverbose=%s\ncmd_arg=%s" "$conf_only" "$dry_run" "$rate_limit" "$verbose" "$cmd_arg"
+  printf "options: conf_only=%s\ndry_run=%s\nrate_limit=%s\nverbose=%s\ncmd_arg=%s" "$conf_only" "$dry_run" "$rate_limit" "$verbose" "$cmd_arg"
 fi
 ### end options parsing
 
@@ -126,25 +135,39 @@ fi
 # set default targets
 if [[ ! -v targets && ! $source ]]; then
   if [[ $HOSTNAME != "$MAIL_HOST" ]] && $cron ; then
-    echo "We are not MAIL_HOST, nothing to do"
+    echo "MAIL_HOST=$MAIL_HOST, nothing to do"
     exit 0
   fi
+
+  at_work=false
+
   case $HOSTNAME in
-    kw|x2)
-      if ping -q -c1 -w1 iank.vpn.office.fsf.org &>/dev/null; then
+    kw)
+      at_work=true
+      ;;&
+    x2|x3)
+      if ping -q -c1 -w1 hal.office.fsf.org \
+              && ip n show 192.168.0.26 | grep . &>/dev/null; then
+      at_work=true
+      fi
+      ;;&
+    kw|x2|x3)
+      if $at_work && ping -q -c1 -w1 iank.vpn.office.fsf.org &>/dev/null; then
         home=iank.vpn.office.fsf.org
       else
-        home=$HOME_DOMAIN
+        home=b8.nz
       fi
       ;;&
     kw)
       targets=($home x2)
       ;;
-    x2)
+    x2|x3)
       targets=($home kw)
       ;;
     tp)
-      targets=(frodo kd)
+      # kd disabled temporarily while its hot and i plan to work on it.
+      #targets=(frodo kd)
+      targets=(frodo x3.b8.nz)
       # might not be connected to the vpn
       if timeout -s 9 10 ssh kw :; then
         targets+=(kw)
@@ -187,14 +210,23 @@ else
     #    ;;
     *)
       prospective_mps=(/a /q)
-      if [[ $HOSTNAME == "$MAIL_HOST" ]]; then
-        prospective_mps+=(/o)
+      if [[ $source ]]; then
+        source_state="$(ssh $source cat /a/bin/bash_unpublished/source-state)"
+        eval "$source_state"
+        source_host="$(ssh $source cat /etc/hostname)"
+        if [[ $source_host == "$MAIL_HOST" ]]; then
+          prospective_mps+=(/o)
+        fi
+      else
+        if [[ $HOSTNAME == "$MAIL_HOST" ]]; then
+          prospective_mps+=(/o)
+        fi
       fi
       ;;
   esac
   for mp in ${prospective_mps[@]}; do # default mountpoints to sync
     if [[ -e /nocow/btrfs-stale/$mp ]]; then
-      echo "$pre warning: $mp stale, not adding to default mountpoints"
+      e "warning: $mp stale, not adding to default mountpoints"
       continue
     fi
     if awk '{print $2}' /etc/fstab | grep -xF $mp &>/dev/null; then
@@ -205,7 +237,14 @@ fi
 
 echo "mountpoints: ${mountpoints[*]}"
 
+##### end command line parsing ########
 
+if [[ $source ]]; then
+  if [[ $(ssh $source systemctl is-active btrbk.service) != inactive ]]; then
+    echo "$0: error: cron btrbk is running on source. exiting out of caution"
+    exit 1
+  fi
+fi
 
 # pull_reexec stops us from getting into an infinite loop if there is some
 # kind of weird problem
@@ -216,11 +255,11 @@ for m in "${mountpoints[@]}"; do
     break
   fi
 done
-if ! $pull_reexec && [[ $source ]] && $pulla ; then
+if ! $pull_reexec && [[ $source ]] && $pulla ; then
   tmpf=$(mktemp)
   scp $source:/a/bin/distro-setup/btrbk-run $tmpf
   if ! diff -q $tmpf $BASH_SOURCE; then
-    echo "$pre found newer version on host $source. reexecing"
+    e "found newer version on host $source. reexecing"
     install -T $tmpf /usr/local/bin/btrbk-run
     m /usr/local/bin/btrbk-run --pull-reexec "${orig_args[@]}"
     exit
@@ -228,7 +267,6 @@ if ! $pull_reexec && [[ $source ]] && ! $pulla ; then
 fi
 
 
-##### end command line parsing ########
 
 
 
@@ -244,7 +282,7 @@ mkdir -p /mnt/root/btrbk
 local_zone=$(date +%z)
 
 if [[ $source ]]; then
-  if ! zone=$(ssh root$source date +%z); then
+  if ! zone=$(ssh root@$source date +%z); then
     die failed to ssh to root@$source
   fi
   if [[ $zone != $local_zone ]]; then
@@ -255,22 +293,35 @@ else
 
   sshable=()
   sshfail=()
+  min_idle_ms=$((1000 * 60 * 15))
   for h in ${targets[@]}; do
     if zone=$(ssh root@$h "mkdir -p /mnt/root/btrbk && date +%z"); then
+      # This is a separate ssh because xprintidle can fail and thats ok.
+      if $cron && idle_ms=$(ssh $h DISPLAY=:0 xprintidle); then
+        if (( idle_ms < min_idle_ms )); then
+
+          # Ignore this host. i sometimes use a non-main machine for
+          # testing or web browsing, knowing that everything will be wiped
+          # by the next backup, but I dont want it to happen as Im using
+          # it from cronjob.
+          e "warning: $h: active X session in the last 15 minutes, skipping for now"
+          continue
+        fi
+      fi
       sshable+=($h)
+      if [[ $zone != $local_zone ]]; then
+        die "error: dont confuse yourself with multiple time zones. $h has different timezone than localhost"
+      fi
     else
       sshfail+=($h)
     fi
-    if [[ $zone != $local_zone ]]; then
-      die "error: dont confuse yourself with multiple time zones. $h has different timezone than localhost"
-    fi
   done
-  if [[ ! $sshable ]] || { ! $cron && [[ $sshfail ]]; }; then
+  if [[ ! ${sshable[@]} ]] || { ! $cron && [[ ${sshfail[@]} ]]; }; then
     die "failed to ssh to hosts: ${sshfail[*]}"
   else
-    if [[ $sshfail ]]; then
+    if [[ ${sshfail[@]} ]]; then
       ret=1
-      echo "$pre error: failed to ssh to ${sshfail[*]} but continuing with other hosts"
+      e "error: failed to ssh to ${sshfail[*]} but continuing with other hosts"
     fi
     targets=(${sshable[@]})
   fi